/* raw2au.c: Conversie van raw formaat naar .au/.snd
 * Copyright (C) 1997,1998 W.H.Scholten
 *
 */

/*__________________INCLUDES___________________*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* comment out for english text: */
#define NL

#ifdef NL
#  define NL_T(t) t
#  define ENG_T(t)
#else
#  define NL_T(t)
#  define ENG_T(t) t
#endif

/*__________________PROGRAMMA___________________*/
int main(int argc, char *argv[]) {
	char filein[100], fileuit[100], string[20];
	char beschrijving[256];
	unsigned char byte;
	FILE *fpin, *fpuit;
	int  type, speed, data_start, data_length, channels;
	int  i;

	printf(
		NL_T("Audio conversie: raw -> au\n")
		ENG_T("Audio conversion: raw -> au\n")
		);
	if (argc<2) {
		printf(
			NL_T("Naam van het om te zetten bestand ?")
			ENG_T("Name of the file to be converted ?")
			);
		scanf("%50s", filein);
	} else strcpy(filein, argv[1]);

	strcpy(fileuit, filein);
	if(!strcmp(fileuit+strlen(fileuit)-4, ".raw")) fileuit[strlen(fileuit)-4]=0;
	strcat (fileuit, ".au");

	if (argc<3) {
		printf(
			NL_T("Frequentie ?")
			ENG_T("Frequency ?")
			);
		scanf("%50s", string);
	} else strcpy(string, argv[2]);
	speed=atol(string);

	if (argc<4) {
		printf(
			NL_T("Kanalen ?")
			ENG_T("Channels ?")
			);
		scanf("%50s", string);
	} else strcpy(string, argv[3]);
	channels=atol(string);

	if (argc<5) {
		printf(
			NL_T("Type ?")
			ENG_T("Channels ?")
			" (8/16/mulaw)"
			);
		scanf("%50s", string);
	} else strcpy(string, argv[4]);
	if (strcmp(string, "mulaw")) type=1;
	else if (strcmp(string, "8")) type=2;
	else if (strcmp(string, "16")) type=3;

	if (argc<6) {
		printf(
			NL_T("Beschrijving ?")
			ENG_T("Description ?")
			);
		scanf("%50s", beschrijving);
	} else strcpy(beschrijving, argv[3]);


	fpin=fopen(filein,"r");
	if (fpin==NULL) {
		printf(NL_T("Bestand ") ENG_T("File "));
		printf(filein);
		printf(NL_T(" is niet te openen\n\n") ENG_T(" cannot be opened\n\n"));
		exit(1);
	}

	fpuit=fopen(fileuit,"w");

	fseek(fpin, 0L, SEEK_SET);

	printf(" %s > %s\n\n", filein, fileuit);

	/* au header */
	fprintf(fpuit, ".snd");

	data_start=6*4+strlen(beschrijving);
	for (i=3; i>=0; i--) {
		byte =((data_start >> (i*8))&255);
		fwrite(&byte,1,1,fpuit);
	}

	fseek(fpin,0L, SEEK_END);
	data_length=ftell(fpin);
	for (i=3; i>=0; i--) {
		byte =((data_length >> (i*8))&255);
		fwrite(&byte,1,1,fpuit);
	}

	for (i=3; i>=0; i--) {
		byte =((type >> (i*8))&255);
		fwrite(&byte,1,1,fpuit);
	}

	for (i=3; i>=0; i--) {
		byte =((speed >> (i*8))&255);
		fwrite(&byte,1,1,fpuit);
	}

	for (i=3; i>=0; i--) {
		byte =((channels >> (i*8))&255);
		fwrite(&byte,1,1,fpuit);
	}
	fprintf(fpuit, beschrijving);

	/* schrijf de gegevens */
	fseek(fpin,0L, SEEK_SET);
	while (1) {
		fread(&byte,1,1,fpin);
		if (feof(fpin)) break;
		fwrite(&byte,1,1,fpuit);
	}
	return 0;
}
